
/*********************************************************************
 * (C) Copyright 1999 Albert Ludwigs University Freiburg
 *     Institute of Computer Science
 *
 * All rights reserved. Use of this software is permitted for 
 * non-commercial research purposes, and it may be copied only 
 * for that use.  All copies must include this copyright message.
 * This software is made available AS IS, and neither the authors
 * nor the  Albert Ludwigs University Freiburg make any warranty
 * about the software or its performance. 
 *********************************************************************/





/*********************************************************************
 * File: cnfout.h
 * Description: headers for cnf output
 *
 * Author: Joerg Hoffmann 2003
 *
 *********************************************************************/ 

#ifndef _CNFOUT_H
#define _CNFOUT_H


#define MAX_CLAUSES 64000000
#define MAX_CNF_VARS 1500000
#include <solver.h>

int do_cnf_output(solver* minisat, int create );


int code;

int **lcode;
int *lop_to_code;
int *ltime_to_code;

int **fcode;
int *fop_to_code;
int *ftime_to_code;

char *code_type;
//Q. Lv 2008-4-4
int  *code_cost;


int print_action_based_encoding(solver* minisat, int layer, int toCreate );
//int print_gpstyle_action_based_encoding( int layer, int toCreate );
//int print_gp_based_encoding( int layer, int toCreate );
int print_thin_gp_based_encoding(solver* minisat, int layer, int toCreate );


//void init_solver();

void* execute_solver();
void* thread_solve();
void  set_priority(solver* s, int layer);
//Q. Lv 2008-4-10
//void post_solving(int solverResult);
void post_solving(int curr_layer);
void generate_static_londex(solver *s);
void validate_model_with_londex(solver* s);

void memory_usage_evaluation(solver *s);
//clause* apply_constraints(solver* s,  lit l);
//int apply_count;
//int apply_generate;
double londex_check_time_bin ;
double londex_check_time_long;

#endif /* _CNFOUT_H */
