#ifndef _PRETREAT_H
#define _PRETREAT_H

#include <stdio.h>
#include <string.h>


#define MAX_LENGTH		256
#define MAX_LINE_LEN	1000

#define COMMENT_TOK		273
#define DEFINE_TOK		274
#define REQUIREMENTS_TOK 275
#define ACTION_TOK		276
#define OPEN_PAREN		277
#define CLOSE_PAREN		278
#define ACTION_COSTS_TOK 279
#define TOTAL_COST_TOK	280
#define METRIC_TOK		281
#define FUNCTIONS_TOK	282
#define OTHERS_TOK		283
#define INCREASE_TOK	284
#define MINIMIZE_TOK	285
#define NUMBER_TOK		286
#define LINEEND_TOK		287
#define EQUAL_TOK		288

int key_word(char **in);
void skip_space(char** in);
void skip_backToken(char** in);
int get_Token(char** in);
int get_nextToken(char**in, FILE *fin);
void read_line(char *line, FILE *fin);
int get_backParen(char** in);
int get_backEqual(char** in);

void pretreat_ops_file(char* filein, char* fileout);
void pretreat_fct_file(char* filein, char* fileout);

void scan_ops_file(char* ops_file);
void scan_fct_file(char* fct_file);


#endif //_PRETREAT_H


